
disp('----------- displayResult.m ------------');

path = '/u/studenter/fasselan/HMM_testing/Test/';
filepath = [path 'tempFiles/' 'recData.mat'];
load(filepath);

m1 = mean(finalRes(1,1,:));
m2 = mean(finalRes(1,2,:));
m3 = mean(finalRes(2,1,:));
m4 = mean(finalRes(2,2,:));
m11 = sum(finalResNUM(1,1,:));
m21 = sum(finalResNUM(1,2,:));
m31 = sum(finalResNUM(2,1,:));
m41 = sum(finalResNUM(2,2,:));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varArray = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/inputVar.lis','%s');
attrMix
antiAttrMix
%  nS = 5;
%  nM = 5;
%  vS = 40;
%  Nfiles = 10;
p = str2double(char(varArray(1)));
if p == 1
p = 'phonemes';
else
p = 'attributes';
end
nS = str2double(char(varArray(2)));
nM = str2double(char(varArray(3)));
vS = str2double(char(varArray(4)));
Nfiles = str2double(char(varArray(5)));
%Nfiles  = round(Nfiles/3);
decRule = str2double(char(varArray(7)));
NfilesTest = str2double(char(varArray(8)));
mfcTrigger = str2double(char(varArray(9)));
if decRule == 1
decRule = 'EER';
else
decRule = 'MER';
end

if mfcTrigger == 1
mfcT = 'Feature_Vectors';
elseif mfcTrigger == 2
mfcT = 'MFCCs';
elseif mfcTrigger == 3
mfcT = 'Feature_Vectors_AND_MFCCs';
elseif mfcTrigger == 4 
mfcT = 'Feature_Vectors_(MFCC_E)';
else
mfcT = 'Feature_Vectors_(MFCC_E)_FILT';
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


disp(sprintf('\n\n\n'));
disp(' ');
disp(' ');
disp(sprintf('|-------------------------------------|'))
disp(sprintf('|                                     |'))
disp(sprintf('|            Results from             |'))
disp(sprintf('|          Speech Recognition         |'))
disp(sprintf('|         using HTK and Matlab.       |'))
disp(sprintf('|       Detection is done on each     |'))
disp(sprintf('|            10 ms frame.             |'))
disp(sprintf('|                                     |'))
disp(sprintf('|            Developed by             |'))
disp(sprintf('|      Claus Fasseland 13.03.2007     |'))
disp(sprintf('|            NTNU, Norway             |'))
disp(sprintf('|                                     |'))
disp(sprintf('|-------------------------------------|\n\n\n'))
disp(' ');
klokka = clock;
disp(sprintf('%-2d.%-2d.%-4d  %-2d:%-2d:%-2d',klokka(3),klokka(2),klokka(1),klokka(4),klokka(5),round(klokka(6))));
disp(' ');
disp(sprintf('|------------------------------------------------------|'))
disp(sprintf('|                                                      |'))
disp(sprintf('|  Decision Type:              %-10s              |',p))
disp(sprintf('|  Number of Mixtures:         %-2.0d                      |',nM))
disp(sprintf('|  Number of States:           %-2.0d                      |',nS))
disp(sprintf('|  Vector Size:                %-2.0d                      |',vS))
disp(sprintf('|  Number of files (training): %-5.0d                   |',Nfiles))
disp(sprintf('|  Number of files (testing):  %-5.0d                   |',NfilesTest))
disp(sprintf('|  Decision Rule:              %-4s                    |',decRule))
disp(sprintf('|  Speech Representation:      %-22s  |',mfcTrigger))
disp(sprintf('|                                                      |'))
disp(sprintf('|------------------------------------------------------|'))
disp(' ');
disp(sprintf('|-------------|         |-------------|'))
disp(sprintf('|  Result %%   |         |   Result    |'))
disp(sprintf('|-------------|         |-------------|'))
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',m1,m2,m11,m21))
disp(sprintf('|------|------|         |------|------|'))
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',m3,m4,m31,m41))
disp(sprintf('|-------------|         |-------------|'))

fid = fopen('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/attributes.lis','r','b');
t = fscanf(fid,'%s\n',1);

if(strcmp(t,'q')==1)
attributeArray = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/phonemes.lis','%s');

else
attributeArray = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/attributes_REAL_NAMES.lis','%s');
end
fclose(fid);

for i=0:(length(attributeArray) - 1)
	if i==0
	disp(' ')
	disp(sprintf('|---------------------------------------------------------------|'));	 
	disp(sprintf('|  Nr  |     Attribute     |     Result %%    ||     Result      |'));
	disp(sprintf('|--------------------------|-----------------||-----------------|'));
	else
	disp(sprintf('|%-6.0d|%-19s|%-8.2f|%-8.2f||%-8.0f|%-8.0f|',i,char(attributeArray(i)),finalRes(1,1,i),finalRes(1,2,i),finalResNUM(1,1,i),finalResNUM(1,2,i)));
	disp(sprintf('|      |                   |--------|--------||--------|--------|'));
	disp(sprintf('|      |                   |%-8.2f|%-8.2f||%-8.0f|%-8.0f|',finalRes(2,1,i),finalRes(2,2,i),finalResNUM(2,1,i),finalResNUM(2,2,i)));
	disp(sprintf('|------|-------------------|------------------------------------|'));
	end
end
