% Funksjon for aa velge ut egnede egenskaper basert paa forhaandslagde matriser. de blir lagret under matlab-mappen som feaSel.mat

disp('----------- featureSelect.m ------------');

% filnavn til parametfil inputVar.lis
path_inputVar = '/u/studenter/fasselan/HMM_testing/Test/lists/462_set/inputVar.lis';

% Innlesing av parameter fra inputVar.lis
varArrayInputVar = textread(
path_inputVar,'%s');
feaSelStatus = str2double(char(varArrayInputVar(15)));
mfcTrigger = str2double(char(varArrayInputVar(9)));
path = char(varArray(17));
TIMITpath = char(varArray(18));
listpath = char(varArray(19));
matlabpath = char(varArray(20));


% filnavn til parametfil feaSelVar.lis
path_feaSelVar = '/u/studenter/fasselan/HMM_testing/Test/lists/462_set/feaSelVar.lis';

% Innlesing av parameter fra feaSelVar.lis
varArray = textread(path_feaSelVar,'%s');
attributeNr = str2double(char(varArray(1)))
filelist_train = char(varArray(2))
filelist_trainORG = char(varArray(3))
NFiles = str2double(char(varArray(4)))
type = char(varArray(6))
filelistSel = char(varArray(7))

filepath = [path matlabpath '/feaSel.mat'];
load(filepath);

% velger egenskapsmatrise
all = ones(20,14);
allMFCC = ones(13,14);
if feaSelStatus == 1
feaSel = filtrert;
elseif feaSelStatus == 2
feaSel = notFilt_med_usikre;
elseif feaSelStatus == 3
feaSel = notFilt_sikker;
elseif feaSelStatus == 4
feaSel = allMFCC;
elseif feaSelStatus == 5
feaSel = notFilt_med_flere_usikre;
elseif feaSelStatus == 6
feaSel = notFilt_mhp_Korr;
else
feaSel = all;
end

feaSelArray = feaSel(:,attributeNr);

if feaSelStatus == 2
feaSelArray(13) = 1;
end

antFea = sum(feaSelArray)
ind = find(feaSelArray==1);
ind = ind';
s = eq(type(2),'r');
if s == 1
disp('TRAIN')
fid_mfc_INN = fopen(filelist_train,'r','b');
fid_mfc_OUT = fopen(filelistSel,'r','b');
else
disp('TEST')
filelist_test = filelist_trainORG;
fid_mfc_INN = fopen(filelist_test,'r','b');
fid_mfc_OUT = fopen(filelistSel,'r','b');
end

fea_all = [];

% ved bruk av mfcc paa htk-format kopieres de direkte
if feaSelStatus == 4
copyfile(['/u/studenter/fasselan/TIMIT/htk_mfc_' type '/*'],['/u/studenter/fasselan/TIMIT/feaSel_' type])
else
	
	% Et sett med egenskaper blir valgt ut for hver ramme
	disp(' ---- Selection starts ---- ');
	for kfile = 1:NFiles
	%lese fil
	fileINN = fgetl(fid_mfc_INN);
	fid2 = fopen(fileINN,'rb','b');
	nframes2=fread(fid2,1,'int32');  % number of frames
	sp2=fread(fid2,1,'int32');  % frame step in micro-sec
	ssb2=fread(fid2,1,'short');  % number of bytes
	ssf2=ssb2/4;                % vector dimension
	sk2=fread(fid2,1,'short');  % feature-kind
	
	fea_mat2=zeros(ssf2,nframes2);
	fea_mat12=fread(fid2,nframes2*ssf2,'float');
	fea_mat2(:)=fea_mat12(1:nframes2*ssf2);
	fea_mat2 = fea_mat2';
	fclose(fid2);
	
	[foer_a foer_b] = size(fea_mat2);
	fea = fea_mat2(:,ind);
	[nf vectorSize] = size(fea);
	fea_all = [fea_all;fea];
	fea = fea';
	fea_sel = fea(:);
	vecS = vectorSize*4;
	
	%skrive til fil
	fileOUT = fgetl(fid_mfc_OUT);
	fid=fopen(fileOUT,'w','b');
		fwrite(fid,nframes2,'int32');
		fwrite(fid,sp2,'int32');
		fwrite(fid,vecS,'short');
		fwrite(fid,sk2,'short');
		fwrite(fid,fea_sel,'float');
	fclose(fid);
	
	end
disp(' ---- Feature selection done ---- ');
end