function r = optThresEERMER(mix,decRule,currAttr,targetChoice)
% Beregner terskelverdi basert paa EER eller MER
%  mix: antall blandingskomponenter
%  decRule: 1 = EER, -1 = MER
% currAtt: attributten som prosesseres
% targetChoice: 2 for vanlig gjenkjenning, 3 for aa gjenkjenne kun midtrammer
 
disp(' ')
disp('---------- optThresEERMER.m ----------')

% Laster inn den logaritmiske differanseverdien for datasettet
pathStr = ['pdfCalc_train_' num2str(mix) '_' currAttr '.mat'];
load(pathStr)
numMix =mix;
proddiffLog = [];
eval(strcat('proddiffLog =', 'pdf_train_',int2str(numMix),';'));
[Nframes dum] = size(proddiffLog);

% Velger ut attributtrammer og anti-attributtrammer
manIndex = find(proddiffLog(:,targetChoice)==1);
man = proddiffLog(manIndex,1);
notmanIndex = find(proddiffLog(:,targetChoice)~= 1);
notman = proddiffLog(notmanIndex,1);

if length(manIndex) > 0
manMean = mean(man)
else
manMean = 0
end
notmanMean = mean(notman)
signTh =1;

% sjekker om middelverdi til attributtene er stoerre/mindre enn resten
% Bergner nedre og oevre grense for terskelverdien
if notmanMean > manMean
    disp('notmanMean is larger than manMean!!!')	
    signTh=-1;
    difference = (manMean -notmanMean)*-1;
    st=manMean - difference*0.5;
    step=difference/100;
    stop = notmanMean + difference*1.5;
else
    difference = (manMean -notmanMean);
    st=notmanMean - difference*0.5;
    step=difference/100;
    stop = manMean + difference*1.5;
end

eerDiff = 10000;
tempPerc = 0;
thresValue =0;
thresValueMax =0;
threshold =st:step:stop;
numThres = length(threshold);
thresh = st;

% Tester alle terskelverdier og bestemmer seg for den som gir best resultat
for f = 1:1:numThres
    frics = find(proddiffLog(:,1)*signTh >thresh*signTh);
    isFrics = zeros(Nframes,1);
    isFrics(frics) =1;

    percentageCorrect =0;
    correct1 = find(proddiffLog(:,2) == 1 & isFrics(:)==1);
    correct2 = find(proddiffLog(:,2) == 0 & isFrics(:)==0);
    wrong1 = find(proddiffLog(:,2) == 1 & isFrics(:)==0);
    wrong2 = find(proddiffLog(:,2) == 0 & isFrics(:)==1);


    numcorr1 =length(correct1);
    numcorr2 =length(correct2);
    numwro1 =length(wrong1);
    numwro2 =length(wrong2);
    if (numcorr1+numwro1) > 0
    percentageCorrect1 = numcorr1/(numcorr1+numwro1)*100;
    percentageWrong1 = numwro1/(numcorr1+numwro1)*100;
    else
    percentageCorrect1 = 0 
    end
    percentageCorrect2 = numcorr2/(numcorr2+numwro2)*100;
    percentageWrong2 = numwro2/(numcorr2+numwro2)*100;
    percentageCorrect = percentageCorrect1 + percentageCorrect2;

    eerDiffTemp = percentageWrong2 - percentageWrong1*decRule;

	if percentageCorrect > tempPerc
	tempPerc = percentageCorrect;
	thresValueMax = thresh;
	end

eerDiffTemp = abs(eerDiffTemp);
    if eerDiffTemp < eerDiff
        eerDiff = eerDiffTemp;
	thresh;
	utskrift = [percentageCorrect1 percentageWrong1; percentageWrong2 percentageCorrect2];		    	
        thresValue = threshold(f);
    end
    thresh = thresh + step;    
end

str = strcat('thresholdValue_',int2str(numMix),'=thresValue');
eval([str ';']);
filepath = ['optThres_',int2str(numMix)];

% Lagre data
save(filepath,strcat('thresholdValue_',int2str(numMix)),'signTh')
r= [thresValue signTh];
disp('----------END optThresEERMER.m ----------')
