function r = pdfCalc(type,nstate,mix,pathStr2,vS,currAttr,mfcT)
% Kalkulerer logaritmisk pdf-verdien for hver ramme
% Inndata:
% type: train eller test
% nstate: antall tilstander (ikke anvendt mer enn 1)
% mix : antall blandingsfordelinger
% pathStr2: fil til attributtens modellparametere
% currAtt: attributten som prosesseres
% mfcT: streng som beskriver anvendte egenskapsvektoren

disp(' ')
disp('---------- pdfCalc2.m ----------')
% Henter inn data prosessert av read_mfc_label2.m 
pathStr3 = ['/u/studenter/fasselan/HMM_testing/Test/tempFiles/mfc_label_' type '_' currAttr '_' mfcT '.mat'];

load(pathStr2);
load(pathStr3);
[Nframes manPl] = size(tar_all);

% beregner standardavvik fra varians
std = sqrt(stm(:,:,:));

nstate = nstate - 2;
nclass = 2;
xdim = vS
sizeFea = size(fea_all)
sizeMum = size(mum)
sizeStd = size(std)

temp = 0;
temp2 = 0;
temp3 = 0;
mum2 = zeros(mix,xdim,nclass);
std2 = zeros(mix,xdim,nclass);
mixWeight2 = zeros(mix,nclass);
[a b c] = size(mum);

mum2 = mum;
std2 = std;
proddiff = [];
proddiffLog = [];
mixWeight
mixWeightNan = sum(sum(isnan(mixWeight)));
feaNaN = sum(sum(isnan(fea_all)));
mumNaN = sum(sum(isnan(mum)));
stmNaN = sum(sum(isnan(stm)));
y1_prod = zeros(Nframes,1);
y2_prod = zeros(Nframes,1);
sansTest = 0;

% Beregner den samlede pdf-verdien paa tvers av blandingskomponenter
for k =1:1:attrMix
    m11 = ones(Nframes,1)*mum2(k,:,1);
    std11 = ones(Nframes,1)*std2(k,:,1);
    pdf1_array= normpdf(fea_all,m11,std11);
    y1_prod = y1_prod + prod(pdf1_array(:,:),2)*mixWeight(k,1);
end

for k =1:1:antiAttrMix
    m22 = ones(Nframes,1)*mum2(k,:,2);
    std22 = ones(Nframes,1)*std2(k,:,2);
    pdf2_array= normpdf(fea_all,m22,std22);
    y2_prod = y2_prod + prod(pdf2_array(:,:),2)*mixWeight(k,1);
end

% Finner differansen mellom logaritmeverdien fra attributt og anti-attributt
proddiff = log(y1_prod + exp(-745)) - log(y2_prod + exp(-745));
proddiffLog = [proddiff tar_all centerTar_all];

manIndex = find(proddiffLog(:,2)==1);
man = proddiffLog(manIndex,1);
notmanIndex = find(proddiffLog(:,2)~= 1);
notman = proddiffLog(notmanIndex,1);
naivTerskel = abs(manMean - notmanMean)/2 + min(notmanMean,manMean);

eval(strcat('pdf_',type,'_',int2str(mix),'=[proddiffLog];'));
filepath = ['pdfCalc_',type,'_',int2str(mix),'_',currAttr,'.mat'];

% Lagre data
delete(filepath)
save(filepath,'pdf1_array','pdf2_array',strcat('pdf_',type,'_',int2str(mix)))
r = [naivTerskel attrMix antiAttrMix];
disp('----------END pdfCalc2.m ----------')