% Dette programmet beregner egenskapsverdien for hver ramme.

%  Egenskapene blir beregnet i rekkefoelgen under:
%  Frekvens F1
%  Frekvens F2
%  Frekvens F3
%  Frekvens F4
%  Amplitude F1
%  Amplitude F2
%  Amplitude F3
%  Amplitude F4
%  Baandbredde F1
%  Baandbredde F2
%  Baandbredde F3
%  Baandbredde F4
%  Grunnfrekvens
%  Stemthetsgrad
%  Spektralflathet
%  Midlet svingning i spekter
%  Nullkryssingsrate
%  Nullkryssingsrate (hoey-pass)
%  Energi ( -F3)
%  Energi (F3-Nyq)

% symbol: >>>>>>>>>>>> indikerer hvor en egenskapsverdi kalkuleres



Fs = 16000; % samplingfrekvens
scale = 100; % number of 10 msec segments in 1 sec

num_fon = 56;

Samp_step = Fs*10/1000;
Samp_wind = Fs*20/1000;
p = 12; N_form = 4;
tresh = 10.0;                   % OBS!
F0MinMax = [50 550];
Time_frame = 40;
Time_step = 10;
SHR_Threshold = .4;
ceiling = 1250;
CHECK_VOICING = 1;
med_smooth = 13;
wham = hamming(Samp_wind);


[n_coef,fg,mg,w] = firpmord( [2800 3500], [1 0], [0.02 0.02], 16000 );
fir_lp = firpm(n_coef,fg,mg,w);
[n_coef,fg,mg,w] = firpmord( [2800 3500], [0 1], [0.02 0.02], 16000 );
fir_hp = firpm(n_coef,fg,mg,w);


feafile_in = 'tr1.mfc';
[fid, message] = fopen(feafile_in, 'r', 'b');
    nframes=fread(fid,1,'int32');  % number of frames
    sp=fread(fid,1,'int32');  % frame step in micro-sec
    ssb=fread(fid,1,'short');  % number of bytes
    
    ssf=ssb/4;                % vector dimension
    sk=fread(fid,1,'short');  % feature-kind
    %disp([nframes sp ssf sk])
    fea_mat=zeros(ssf,nframes);
    fea_mat1=fread(fid,nframes*ssf,'float');
    fea_mat(:)=fea_mat1;
fclose(fid);

type = 'test';
startFilt = 0;

if startFilt == 1
filt = '_filtered';
else
filt = '';
end

fid_mfc = fopen(['/u/studenter/fasselan/HMM_testing/Test/lists/462_set/' type 'All_mfc' filt '.lis'],'r','b');

if(eq(type(2),'r') == 1)
Nfiles = 4620;%305
else
Nfiles = 1680; % total : 157
end

fid_wav = fopen(['/u/studenter/fasselan/HMM_testing/Test/lists/462_set/' type 'All_wav.lis'],'r','b');
fid_phn = fopen(['/u/studenter/fasselan/HMM_testing/Test/lists/462_set/' type 'All_phn.lis'],'r','b');
fea_all = [];
tar_all = [];
f_lengths = [];


disp(' ******** rett foer for loop gjennom alle filer ********')
for kfile = 1:Nfiles
    wavfile = fgetl(fid_wav);

    fid = fopen(wavfile,'rb');
        y = fread(fid,'int16','ieee-be');
        x = y(513:length(y));
    fclose(fid);
    
    Lx = length(x);

if startFilt == 1
  b = [1 -0.98];
  x = filter(b,1,x);
end

% >>>>>>>>>>>> 
%  Frekvens F1
%  Frekvens F2
%  Frekvens F3
%  Frekvens F4
%  Amplitude F1
%  Amplitude F2
%  Amplitude F3
%  Amplitude F4
%  Baandbredde F1
%  Baandbredde F2
%  Baandbredde F3
%  Baandbredde F4

    [ar,e,kf] = lpcauto(x,p,[Samp_step Samp_wind]);
    [NForm,FreqForm,AmpForm,BwForm] = lpcar2fm(ar,tresh);

% klipper bort unaturlige hoeye verdier for amplitude
% egenskapene 5,6,7,8
maxValue = [200 30 10 5];
for maxI = 1:1:4
indexMax = AmpForm(:,maxI)>maxValue(maxI);
AmpForm(indexMax,maxI) = maxValue(maxI);
end

% >>>>>>>>>>>>
%  Grunnfrekvens
%  Stemthetsgrad
    [f0_time,f0_value,SHR,f0_candidates] = shrp(x,Fs,F0MinMax,Time_frame,Time_step,SHR_Threshold,ceiling,med_smooth,CHECK_VOICING);

    x_hp = filtfilt(fir_hp,1,x);
    Nfr = floor((Lx - Samp_wind + Samp_step)/Samp_step); 
    Spec_flat = zeros(Nfr,1);
    Spec_deriv = Spec_flat; zero_cr = Spec_flat; zero_cr_hp = zero_cr; E_0_F3 = zero_cr; E_F3_Nyq = zero_cr;
    
    for i = 1 : Nfr
        frame_start = (i-1)*Samp_step + 1;
        xfr = x(frame_start : frame_start + Samp_wind - 1);
        xfr = xfr.*wham;
        Xfr = abs(fft(xfr,512));
        Xfr = Xfr(1:256);
        Xfr_norm = sqrt(Xfr(1)^2 + Xfr(256)^2 + 2*sum((Xfr(2:255).^2)));
	Xfrn = Xfr/Xfr_norm;

% >>>>>>>>>>>>
%  Spektralflathet
        Spec_flat(i) = sum(log(Xfrn)) - log(sum(Xfrn));

% >>>>>>>>>>>>
%  Midlet svingning i spekter
        Spec_deriv(i) = log(sum(abs(diff(Xfrn))));
        [sp_cor,dum] = zerocros(xfr); 

% >>>>>>>>>>>>
%  Nullkryssingsrate
	zero_cr(i) = length(sp_cor);
        xfr_hp = x_hp(frame_start : frame_start + Samp_wind - 1);
        [sp_cor_hp,dum] = zerocros(xfr_hp); 
	
% >>>>>>>>>>>>
%  Nullkryssingsrate (hoey-pass)
	zero_cr_hp(i) = length(sp_cor_hp);
        F3 = FreqForm(i,3); F3_samp = round(F3*512);
        if((F3 > 1/16) | (F3 < 15/32))
% >>>>>>>>>>>>
%  Energi ( -F3)
            E_0_F3(i) = log(sum((Xfr(1:F3_samp).^2))); 
% >>>>>>>>>>>>
%  Energi (F3-Nyq)
	    E_F3_Nyq(i) = log(sum((Xfr(F3_samp+1:256).^2))); 
        end      
    end

    phnfile =fgetl(fid_phn);
    fid = fopen(phnfile,'r','b');
    tar = [];
    k = 0;
    sind_old = 0;
    
    ss1f = []; ss2f = []; clf = [];
    while 1
        k = k+1;
        ss = fscanf(fid,'%d %d');                 
        if (length(ss) == 0) break; end 
        ss1f = [ss1f ss(1)]; ss2f = [ss2f ss(2)];
        cl = fscanf(fid, '%s',1); clf{k} = cl;
    end
    Nseg = k - 1;
    k = 1;
    while (k < Nseg)
        k = k+1;
        a1 = (strcmp(strtrim(clf{k-1}),'kcl') ==1) & (strcmp(strtrim(clf{k}),'k') == 1);
        a2 = (strcmp(strtrim(clf{k-1}),'bcl') ==1) & (strcmp(strtrim(clf{k}),'b') == 1);
        a3 = (strcmp(strtrim(clf{k-1}),'pcl') ==1) & (strcmp(strtrim(clf{k}),'p') == 1);
        a4 = (strcmp(strtrim(clf{k-1}),'dcl') ==1) & (strcmp(strtrim(clf{k}),'d') == 1);
        a5 = (strcmp(strtrim(clf{k-1}),'tcl') ==1) & (strcmp(strtrim(clf{k}),'t') == 1);
        a6 = (strcmp(strtrim(clf{k-1}),'tcl') ==1) & (strcmp(strtrim(clf{k}),'ch') == 1);
        a7 = (strcmp(strtrim(clf{k-1}),'gcl') ==1) & (strcmp(strtrim(clf{k}),'g') == 1);
        a8 = (strcmp(strtrim(clf{k-1}),'dcl') ==1) & (strcmp(strtrim(clf{k}),'jh') == 1);
            
        if ( a1 || a2 || a3 || a4 || a5 || a6 || a7 || a8)
            ss2f(k-1) = ss2f(k);
            ss1f = [ss1f(1:k-1) ss1f(k+1:Nseg)]; ss2f = [ss2f(1:k-1) ss2f(k+1:Nseg)];
            if (k > 2) 
                clf = [clf(1:k-2) clf(k:Nseg)];
            else
                clf = clf(2:Nseg);
            end
            Nseg = Nseg - 1;            
        end
    end
    for k = 1 : Nseg
            if (strcmp(strtrim(clf{k}),'kcl') ==1) clf{k} = 'k'; end
            if (strcmp(strtrim(clf{k}),'bcl') ==1) clf{k} = 'b'; end
            if (strcmp(strtrim(clf{k}),'tcl') ==1) clf{k} = 't'; end
            if (strcmp(strtrim(clf{k}),'dcl') ==1) clf{k} = 'd'; end
            if (strcmp(strtrim(clf{k}),'gcl') ==1) clf{k} = 'g'; end
            if (strcmp(strtrim(clf{k}),'pcl') ==1) clf{k} = 'p'; end
    end
    fclose(fid);
	M = Nfr - 3;	
    SHR_med = medsmooth(SHR,med_smooth);
    
    For_Freq = zeros(M,N_form); For_Amp = For_Freq; For_Bw = For_Freq;
    [dum,file_form] = size(FreqForm);
    For_valg = min(N_form,file_form); 
    For_Freq(:,1:For_valg) = FreqForm(2:M+1,1:For_valg); 
    For_Amp(:,1:For_valg)  = AmpForm(2:M+1,1:For_valg); 
    For_Bw(:,1:For_valg) = BwForm(2:M+1,1:For_valg);
    
    % Sammenslaaing av alle egenskapsverdier for alle rammer til en matrise
    fea = [For_Freq For_Amp For_Bw f0_value(1:M) SHR_med(1:M) Spec_flat(2:M+1) Spec_deriv(2:M+1) zero_cr(2:M+1) zero_cr_hp(2:M+1) E_0_F3(2:M+1) E_F3_Nyq(2:M+1)];


[ns,ssf] =size(fea);  % define number of frames for file and vector dimension
ss = ssf*4; % number of bytes per frame
fea_all = [fea_all;fea];
fea = fea';
fea_corr = fea(:);

% Skrive data basert paa egnskapsverdiene til fil
mfcfile = fgetl(fid_mfc);
fid=fopen(mfcfile,'w','b');
        fwrite(fid,ns,'int32');
        fwrite(fid,sp,'int32');
        fwrite(fid,ss,'short');
        fwrite(fid,sk,'short');
        fwrite(fid,fea_corr,'float');
fclose(fid);
tar_all = [tar_all;tar];

end
fclose(fid_wav);
fclose(fid_phn);
