function r = read_mfc_label2(mfcList,labelList,attribute,Nfiles,mfcTrigger,type,mfcT)
% Leser inn datafiler og etikettfiler og smelter dem sammen i matriser
% Inndata:
% mfcList: filliste for datafiler
% labelList: filliste for etikettfiler
% attribute: attributten som prosesseres
% Nfiles : antall filer
% mfcTrigger: kildetype
% type: train eller test
% mfcT: streng som beskriver anvendte egenskapsvektoren

disp(' ')
disp(sprintf('----------- read_mfc_label2.m ------------'));
disp(sprintf(mfcList));
disp(sprintf(labelList));
disp(sprintf(attribute));

fid_mlf = fopen(labelList,'r','b');
[fid_mfc message] = fopen(mfcList,'r','b');
mlfstring = fscanf(fid_mlf, '%s',1);
tar_all = [];
centerTar_all = [];
fea_all = [];
counter =0;

    disp(sprintf('\n\n|------------------------------------------------------------------------------------------------------|'))
    disp(sprintf('|  - %-23s                                                                          |',mfcT))
    disp(sprintf('|------------------------------------------------------------------------------------------------------|'))
    disp(sprintf('|                     filename                       | frames | frame step | vector dim | feature kind |'))

% Etikettfiler for hver datafil hentes og legges inn i en stor vektor
% skriver ut filene som prosesseres 
for km = 1:Nfiles
   tar = [];
   centerTar = [];
    M = 0;
    file = fscanf(fid_mlf, '%s',1);
    ss1f = []; ss2f = []; clf = [];
    sind_old =0;
    k=0;
    while 1
        k = k+1;
        ss = fscanf(fid_mlf,'%d %d');                 
        
        if (length(ss) == 0) 
        dummy = fscanf(fid_mlf, '%s',1);             
            break; 
        end 
        ss1f = [ss1f ss(1)];
        ss2f = [ss2f ss(2)];
        cl = fscanf(fid_mlf, '%s',1);
        clf{k} = cl;
    end
    for k = 1:length(clf)
       if (strcmp(attribute,clf(k)) == 1)
           tars = 1;
       else
           tars = 0;
       end
       sind = floor(scale*ss2f(k)/Fs);  % last frame
       seglen = length(sind_old+1:sind);
       sind_old = sind;
       tar = [tar; tars*ones(seglen,1)];

	if tars == 1
	centerTemp = tars*ones(seglen,1);
	antCent = ceil(length(centerTemp)*0.2);
	tempA = tars*zeros(seglen,1);
	lengthCent = length(centerTemp);
	findIfOdd = lengthCent/2 - floor(lengthCent/2);
	ned = round(antCent/2);
	opp = antCent - 1;

		if findIfOdd > 0
		arrayCenter = ceil(lengthCent/2);
		tempA((arrayCenter- ned + 1):(arrayCenter + opp)) = 1;
		else
		arrayCenter = ceil(lengthCent/2) + 1;
		tempA((arrayCenter- ned):(arrayCenter + opp -1)) = 1;
		end
	
	centerTar = [centerTar; tempA];
	else
	centerTar = [centerTar; tars*ones(seglen,1)];
	end
    end


% Leser data fra fil
    mfcfile = fgetl(fid_mfc);   % read filename
    fid = fopen(mfcfile,'rb','b');
    nframes=fread(fid,1,'int32');  % number of frames
    sp=fread(fid,1,'int32');  % frame step in micro-sec
    ssb=fread(fid,1,'short');  % number of bytes
    ssf=ssb/4;                % vector dimension
    sk=fread(fid,1,'short');  % feature-kind

% setter antall rammer for baade etikettvektor og datamatrise
    [M N] = min([length(tar) nframes]);
	if(N==1)
	counter = counter +1;
	end
    M = M -3;

    disp(sprintf('|----------------------------------------------------|--------|------------|------------|--------------|'))
    disp(sprintf('|%-52s|%-8.0d|%-12.0d|%-12.0d|%-14.0d|',mfcfile,M,sp,ssf,sk))	
    
    fea_mat=zeros(ssf,M);
    fea_mat1=fread(fid,M*ssf,'float');
    fea_mat(:)=fea_mat1(1:M*ssf);
    fea_mat = fea_mat';
    fclose(fid);

fea_all = [fea_all;fea_mat];
tar_all = [tar_all; tar(2:M+1)];
centerTar_all = [centerTar_all; centerTar(2:M+1)];
	
end
totalFrames = length(tar_all);
    disp(sprintf('|----------------------------------------------------|-------------------------------------------------|'))
    disp(sprintf('|                          Total number of frames:   |%-8.0d                                         |',totalFrames))
    disp(sprintf('|------------------------------------------------------------------------------------------------------|\n\n'))
fclose(fid_mlf);
fclose(fid_mfc);

% Lagrer data
filepath =['/u/studenter/fasselan/HMM_testing/Test/tempFiles/mfc_label_' type '_' attribute '_' mfcT '.mat'];
delete (filepath)
save (filepath,'fea_all','tar_all','centerTar_all','counter')

% Lagrer etikettfiler for alle attributtyper
target_label = ['/u/studenter/fasselan/HMM_testing/Test/tempFiles/target_label_' type '.mat'];
load(target_label);
type
sT = size(target_label_all)
lengdeTar = length(tar_all)
target_label_all = [target_label_all tar_all];
save (target_label,'target_label_all')

