function r = read_models(mmfFile,modelList,nM,vS)
% Leser modellparameter fra HMM (mmf-fil) generert av HTK
% Inndata
% mmfFile : mmf-fil
% modelList: fil med liste over modellene (attributt og anti-attributt)
% nM : antall blandingskomponenter
% vS : antall egenskaper

disp(mmfFile)
nclass = 2; 
endian = 'b';

% liste over modeller
filename = modelList;
fid = fopen(filename,'r',endian);
phone=fscanf(fid,'%s\n',1);
fonmap = cellstr(phone);
for i = 2:nclass
    phone=fscanf(fid,'%s\n',1);
    fonmap = [fonmap cellstr(phone)];
end
fclose(fid);
for i = 1:nclass
    t = char(fonmap(i));
end

if nM >= 2
jump = 10;
else
jump = 8;
end

dropR = 0;
currAtt = fonmap(1);

% Leser mmf-file
fid_init = fopen(mmfFile,'r',endian);
for j = 1:jump
    s1 = fscanf(fid_init,'%s\n',1);
    switch j
        case 2
            s = fscanf(fid_init,'%d',1);
            s2 = fscanf(fid_init,'%d\n',1);
            xdim = s2;
        case 3
            s = fscanf(fid_init,'%s\n',1);
        case 4
            s = fscanf(fid_init,'%s\n',1);
        case 6
            s2 = fscanf(fid_init,'%d\n',1);
            nstate = s2 - 2
        case 7
            s = fscanf(fid_init,'%s %d\n',1);
        case 8
		if jump == 10
            	s2 = fscanf(fid_init,'%d\n',1);
            	mix = s2
		else
		mix = 1
		s = fscanf(fid_init,'%s %d\n',1);
            	nonsense = fscanf(fid_init,'%d\n',1);
		end
	case 9
		 s = fscanf(fid_init,'%s\n',1);
	case 10
            	s2 = fscanf(fid_init,'%d\n',1);
            	blbabal = s2;
		
    end
end
fclose(fid_init);

a=zeros(nstate,nstate,nclass);
mum=zeros(nstate*mix,xdim,nclass); 
mixWeight = zeros(nstate*mix,nclass);
stm = mum;
numMixInUse = 0;
mixMix = 0;
attrMix = 0;
antiAttrMix = 0;

fid2 = fopen(mmfFile,'r','b');

for class = 1 : nclass
    dropR = 0;	
    mixMix = 0;
    model=char(fonmap(class));
        for j = 1:6
            tull = fgetl(fid2);
        end
        for i=1:nstate
                ss=fscanf(fid2,'%s',1);
                s(i)=fscanf(fid2,'%d\n',1);
            if (mix >= 2)
                numM=fscanf(fid2,'%s',1);
                numMval=fscanf(fid2,'%d\n',1);            
            end
            for p = 1:mix
		mixMix = mixMix + 1;
                if (mix > 1)
			if dropR == 0
			mixNrTag=fscanf(fid2,'%s',1);
			end
		dropR = 0;
                mixNr=fscanf(fid2,'%d',1);
                mixW=fscanf(fid2,'%f\n',1);
                mixWeight((i-1)*mix+p,class)=mixW;
		else	
		mixWeight(1,class) = 1;
		mixWeight(1,class) = 1;
                end    

                mean_s=fscanf(fid2,'%s',1);
                v_size=fscanf(fid2,'%d\n',1);
		temp = fscanf(fid2,'%f\n',v_size);
                temp1 = sprintf('%d',temp);
                mum((i-1)*mix+p,:,class) = temp;
                var_s=fscanf(fid2,'%s',1);
                var_size=fscanf(fid2,'%d\n',1);
                temp2 = fscanf(fid2,'%f\n',var_size);
                temp3 = sprintf('%d',temp2);
		temp2(find(temp2==0)) = 0.0001;
                stm((i-1)*mix+p,:,class) = temp2;
                gcs=fscanf(fid2,'%s',1);
		
			if (eq(gcs(2),'G')==1)
			gc=fscanf(fid2,'%f',1);
			trans_mean =fscanf(fid2,'%s',1);
				if(eq(trans_mean(2),'T')==1)
				disp('fant en <TRANSP>, hopper ut')
				dropR = 1;
				break;
				end
			dropR = 1;
			elseif(eq(gcs(2),'T')==1)
			dropR = 1;
			break;
			else
			dropR = 1;
			end
			
			if mixNr == mix
			break;
			end
            end
        end
		if dropR == 0
		trs=fscanf(fid2,'%s',1);
		else
		disp('og havnet her')
		end
		trns=fscanf(fid2,'%d\n',1);
		addstate=nstate+2;
	
		for i=0:addstate-1
		for h=0:addstate-1
		dummy=fscanf(fid2,'%f',1);
		a(i+1,h+1,class)=dummy;
		end
		end
        ehs=fscanf(fid2,'%s\n',1);
	
	if class == 1
	attrMix = mixMix
	else
	antiAttrMix = mixMix
	end	
	
		
end
fclose(fid2);  

% Lagrer data
filepath =strcat('/u/studenter/fasselan/HMM_testing/Test/tempFiles/model_',char(currAtt),'_M',num2str(nM),'.mat');
delete (filepath)
save (filepath, 'mum', 'stm','attrMix','antiAttrMix', 'mixWeight', 'a', 'fonmap')
            