% Hovedfunksjon for testingsdelen
% Flere andre funksjoner blir eksekvert nedenfor i denne rekkefoelgen:

% read_mfc_label2.m
% pdfCalc2.m
% testData2.m

disp(' ')
disp(sprintf('---- recMatlab.m -----'));

% filnavn til parametfil inputVar.lis
path_inputVar = '/u/studenter/fasselan/HMM_testing/Test/lists/462_set/inputVar.lis';

% Innlesing av parameter fra inputVar.lis
varArray = textread(path_inputVar,'%s');
p = str2double(char(varArray(1)));
nS = str2double(char(varArray(2)));
nM = str2double(char(varArray(3)));
vS = str2double(char(varArray(4)));
Nfiles = str2double(char(varArray(8)));
%Nfiles  = round(Nfiles/3);
decRule = str2double(char(varArray(7)));
mfcTrigger = str2double(char(varArray(9)));
targetChoice = str2double(char(varArray(12)));
path = char(varArray(17))
TIMITpath = char(varArray(18))
listpath = char(varArray(19))

% Innlesing av parameter fra feaSelVar.lis
varArray2 = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/feaSelVar.lis','%s');
vS = str2double(char(varArray2(5)))
filelistSel = char(varArray2(7))

% henter inn liste over attributter
fid_att = fopen([path listpath 'attributes.lis'], 'r', 'b');

if p == 1
p = 'phonemes';
else
p = 'attributes';
end
if decRule == 1
decRule = 'EER';
else
decRule = 'MER';
end

teller = 1;
t = fscanf(fid_att,'%s\n',1);
attributeArray = cellstr(t);
while 1
t = fscanf(fid_att,'%s\n',1);
if(strcmp(t,'END')==1)break;end
attributeArray = [attributeArray cellstr(t)];
end
fclose(fid_att);
antAtt = length(attributeArray); % antall attributter

% Henter inn terskelverdi
filepath = [path 'tempFiles/' 'threshold.mat'];
load(filepath);
recFile = [path 'tempFiles/recData.mat'];
load(recFile);
recTeller  = recTeller +1;
currAttr = attributeArray(recTeller); % current attribute
currAttr = char(currAttr);
attStr = ['current attribute being processed is ' currAttr];
disp(' ')
disp(sprintf('%-50s\n',char(attStr)))

% 'Master Label File' for den aktuelle attributten
labelList = [path listpath 'RecAttribute.mlf'];
type = 'test';

% Liste over mulige fillister
mfcList1 = [path listpath 'testAll_mfc.lis'];
mfcList2 = [path listpath 'test462_mfc2.lis'];
mfcList3 = [path listpath 'test462_htk_AND_FEmfc.lis'];
mfcList4 = [path listpath 'test462_mfc_NEW.lis'];
mfcList5 = [path listpath 'test462_mfc_NEW_filtered.lis'];
mfcList6 = [path listpath 'test462_mfc_NEW_reducedFEA.lis'];

if mfcTrigger == 1
mfcList = mfcList1;
mfcT = 'Feature_Vectors';
elseif mfcTrigger == 2
mfcList = mfcList2;
mfcT = 'MFCCs';
elseif mfcTrigger == 3
mfcList = mfcList3;
mfcT = 'Feature_Vectors_AND_MFCCs';
elseif mfcTrigger == 4 
mfcList = mfcList4;
mfcT = 'Feature_Vectors_(MFCC_E)';
elseif mfcTrigger == 6 
mfcList = mfcList6;
mfcT = 'Feature vectors_E_redFEA';
else
mfcList = mfcList5;
mfcT = 'Feature_Vectors_(MFCC_E)_FILT';
end
mfcList = filelistSel;

% lese filer og tilegne korrekte etiketter
cd Matlab;
read_mfc_label2(mfcList,labelList,currAttr,Nfiles,mfcTrigger,type,mfcT);
cd ..;

% Kalkulerer logaritmisk pdf-verdien for hver ramme
model = [path 'tempFiles/' 'model_' currAttr '_M' num2str(nM) '.mat']
cd Matlab;
r = pdfCalc2(type,nS,nM,model,vS,currAttr,mfcT);
cd ..;

% antall "aktive" blandingsfordelinger for henholdsvis
% attributt og anti-attributt
attrMix = r(2);
antiAttrMix = r(3);

% Kalkulere gjenkjenningsraten
testdatapath = [path 'tempFiles/testData_M' num2str(nM) '_feature' num2str(mfcTrigger) '_' p '_' decRule '.mat'];
cd Matlab;
recResults = testData2(testdatapath, filepath, nM,recTeller,currAttr,targetChoice);
cd ..;
finalRes(:,:,recTeller) = recResults(:,1:2);
finalResNUM(:,:,recTeller) = recResults(:,3:4);
edgeError = [edgeError recResults(1,5)];

if recTeller == antAtt
m1 = mean(finalRes(1,1,:));
m2 = mean(finalRes(1,2,:));
m3 = mean(finalRes(2,1,:));
m4 = mean(finalRes(2,2,:));
m11 = sum(finalResNUM(1,1,:));
m21 = sum(finalResNUM(1,2,:));
m31 = sum(finalResNUM(2,1,:));
m41 = sum(finalResNUM(2,2,:));
disp(sprintf('\n\n\n'));
disp(sprintf('|-------------|         |-------------|'));
disp(sprintf('|  Result %%   |         |   Result    |'));
disp(sprintf('|-------------|         |-------------|\n\n'));
disp(sprintf('|-------------|         |-------------|'));
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',m1,m2,m11,m21));
disp(sprintf('|------|------|         |------|------|   '));
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',m3,m4,m31,m41));
disp(sprintf('|-------------|         |-------------|'));
end

% Lagrer data
save(recFile,'recResults','finalRes','finalResNUM','recTeller','attrMix','antiAttrMix','edgeError');
disp(' ')
disp('End of testing')