function r = testData2(testdatapath,pa2,numMix,recTeller,currAttr,targetChoice)
% Funksjon som beregner gjenkjenningsraten til attributt X
% Inndata:
% testdatapath : filnavn for lagring av testdata
% pa2 : fil som inneholder terskelverdier
% numMix : antall blandingsfordelinger
% recTeller : iterasjonsnummer (for oekning i blandingsfordelinger)
% currAtt: attributten som prosesseres
% targetChoice: 2 for vanlig gjenkjenning, 3 for aa gjenkjenne kun midtrammer

disp(' ');
disp('----- testData2.m -----\n');

% Laster inn den logaritmiske differanseverdien for datasettet
pa1 = ['pdfCalc_test_' int2str(numMix) '_' currAttr '.mat'];
load(pa1) % pdf values
load(pa2) % threshold values
proddiffLog = [];
eval(strcat('proddiffLog =', 'pdf_test_',int2str(numMix),';'));
[Nframes manPl] = size(proddiffLog);
thresh = thresholds(recTeller)

% Sjekker fortegnsverdi fra terskelberegning.
signThVal = signTh(recTeller);
if(signThVal == 1)
manEstIndex = find(proddiffLog(1:Nframes,1) > thresh);
else
manEstIndex = find(proddiffLog(1:Nframes,1) < thresh);
end
manEst = zeros(Nframes,1);
manEst(manEstIndex) =1;
tar = proddiffLog(:,2);

% Beregner antall transisjonsrammer som feildetekteres
edgeFrames = 0;
tempCount1 = 0;
tempCount2 = 0;
for i=3:Nframes-2
	if tar(i) == 1 
		if tar(i) ~= tar(i-1)
			if manEst(i) ~= tar(i)
			edgeFrames = edgeFrames + 1;
			tempCount1 = i;
			end
			if manEst(i+1) ~= tar(i+1)
			edgeFrames = edgeFrames + 1;
			tempCount2 = i+1;
			end	
		end
		if tar(i) ~= tar(i+1)
			if manEst(i) ~= tar(i) && i ~= tempCount2
			edgeFrames = edgeFrames + 1;	
			end
			if manEst(i-1) ~= tar(i-1)  && (i-1) ~= tempCount1
			edgeFrames = edgeFrames + 1;	
			end
		end
	end
end

edgeError = edgeFrames/Nframes;
eArray = [edgeError 0; 0 0];

% kalkulerer gjenkjenningsraten:
% Korrekt gjenkjent rammer for attributt X
% Korrekt gjenkjent rammer for anti-attributt X
% Feil aksepterte rammer
% Feil forkastede rammer
correct1 = find(proddiffLog(:,targetChoice) == 1 & manEst(:)== 1);
correct2 = find(proddiffLog(:,targetChoice) == 0 & manEst(:)== 0);
wrong1 = find(proddiffLog(:,targetChoice) == 1 & manEst(:)== 0);
wrong2 = find(proddiffLog(:,targetChoice) == 0 & manEst(:)== 1);
corr1 = zeros(Nframes,1);
corr2 = zeros(Nframes,1);
wro1 = zeros(Nframes,1);
wro2 = zeros(Nframes,1);
corr1(correct1)=1;
corr2(correct2)=1;
wro1(wrong1)=1;
wro2(wrong2)=1;
numcorr1 = sum(corr1);
numcorr2 = sum(corr2);
numwro1 = sum(wro1);
numwro2 = sum(wro2);
if (numcorr1+numwro1) > 0
perCorr1 = (numcorr1)/(numcorr1+numwro1)*100;
perWro1 = (numwro1)/(numcorr1+numwro1)*100;
else
perCorr1 = 0;
perWro1 = 0;
end
perCorr2 = (numcorr2)/(numcorr2+numwro2)*100;
perWro2 = (numwro2)/(numcorr2+numwro2)*100;
numCorr = [numcorr1 numwro1;numwro2 numcorr2];
percentage_array = [perCorr1 perWro1;perWro2 perCorr2];

disp(sprintf('|-------------|         |-------------|'));
disp(sprintf('|  Result %%   |         |   Result    |'));
disp(sprintf('|-------------|         |-------------|\n\n'));
disp(sprintf('|-------------|         |-------------|'));
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',percentage_array(1,1),percentage_array(1,2),numCorr(1,1),numCorr(1,2)));
disp(sprintf('|------|------|         |------|------|   '));
disp(sprintf('|%-6.2f|%-6.2f|         |%-6.0f|%-6.0f|',percentage_array(2,1),percentage_array(2,2),numCorr(2,1),numCorr(2,2)));
disp(sprintf('|-------------|         |-------------|'));

r= [percentage_array numCorr eArray];
% Lagrer data
filepath = testdatapath;
eval(strcat('resultArray_',int2str(numMix),'=r;'));
delete(filepath)
save(filepath,strcat('resultArray_',int2str(numMix)))
