function r = testTrainData(testdatapath,thresh,numMix,currAttr,targetChoice,trainRecAll,signTh)
% Funksjon for beregning av gjenkjenningsrate fra treningssettet
% Inndata:
% testdatapath : filnavn for lagring av testdata
% thresh: terskel
% numMix : antall blandingsfordelinger
% currAtt: attributten som prosesseres
% targetChoice: 2 for vanlig gjenkjenning, 3 for aa gjenkjenne kun midtrammer
% trainRecAll: fil for lagring av alle resultater fra trening paa tvers av attributter
% signTh : fortegn for terskelverdi


disp(' ');
disp('----- testTrainData.m -----\n');

% Laster inn den logaritmiske differanseverdien for datasettet
pa1 = ['pdfCalc_train_' int2str(numMix) '_' currAttr '.mat'];
load(pa1) 
load(trainRecAll);
proddiffLog = [];
eval(strcat('proddiffLog =', 'pdf_train_',int2str(numMix),';'));
[Nframes manPl] = size(proddiffLog);

% Sjekker fortegnsverdi fra terskelberegning.
signThVal = signTh;
if(signThVal == 1)
manEstIndex = find(proddiffLog(1:Nframes,1) > thresh);
else
manEstIndex = find(proddiffLog(1:Nframes,1) < thresh);
end
manEst = zeros(Nframes,1);
manEst(manEstIndex) =1;

% kalkulerer gjenkjenningsraten:
% Korrekt gjenkjent rammer for attributt X
% Korrekt gjenkjent rammer for anti-attributt X
% Feil aksepterte rammer
% Feil forkastede rammer
correct1 = find(proddiffLog(:,targetChoice) == 1 & manEst(:)== 1);
correct2 = find(proddiffLog(:,targetChoice) == 0 & manEst(:)== 0);
wrong1 = find(proddiffLog(:,targetChoice) == 1 & manEst(:)== 0);
wrong2 = find(proddiffLog(:,targetChoice) == 0 & manEst(:)== 1);
corr1 = zeros(Nframes,1);
corr2 = zeros(Nframes,1);
wro1 = zeros(Nframes,1);
wro2 = zeros(Nframes,1);
corr1(correct1)=1;
corr2(correct2)=1;
wro1(wrong1)=1;
wro2(wrong2)=1;
numcorr1 = sum(corr1);
numcorr2 = sum(corr2);
numwro1 = sum(wro1);
numwro2 = sum(wro2);
if (numcorr1+numwro1) > 0
perCorr1 = (numcorr1)/(numcorr1+numwro1)*100;
perWro1 = (numwro1)/(numcorr1+numwro1)*100;
else
perCorr1 = 0;
perWro1 = 0;
end
perCorr2 = (numcorr2)/(numcorr2+numwro2)*100;
perWro2 = (numwro2)/(numcorr2+numwro2)*100;
numCorr = [numcorr1 numwro1 numwro2 numcorr2];
percentage_array = [perCorr1 perWro1 perWro2 perCorr2];

trainNumResult = [trainNumResult; numCorr];
trainResult = [trainResult; percentage_array];

% Lagrer data
save([trainRecAll '.mat'],'trainNumResult','trainResult')
save([trainRecAll '_M' int2str(numMix) '.mat'],'trainNumResult','trainResult')
r = trainNumResult