% Hovedfunksjon for treningsdelen
% Flere andre funksjoner blir eksekvert nedenfor i denne rekkefoelgen:

% read_models.m
% read_mfc_label2.m
% pdfCalc2.m
% optThresEERMER.m
% testTrainData.m

disp(sprintf('------- trainMatlab.m -------'))

% filnavn til parametfil inputVar.lis
path_inputVar = '/u/studenter/fasselan/HMM_testing/Test/lists/462_set/inputVar.lis';

% Innlesing av parameter fra inputVar.lis
varArray = textread(path_inputVar,'%s');
p = str2double(char(varArray(1)));
nS = str2double(char(varArray(2)));
nM = str2double(char(varArray(3)));
vS = str2double(char(varArray(4)));
Nfiles = str2double(char(varArray(5)));
decRule = str2double(char(varArray(7)));
mfcTrigger = str2double(char(varArray(9)));
targetChoice = str2double(char(varArray(12)))
path = char(varArray(17))
TIMITpath = char(varArray(18))
listpath = char(varArray(19))

% Innlesing av parameter fra feaSelVar.lis
varArray2 = textread('/u/studenter/fasselan/HMM_testing/Test/lists/462_set/feaSelVar.lis','%s');
vS = str2double(char(varArray2(5)))
filelistSel = char(varArray2(7))

% henter inn liste over attributter
fid_att = fopen([path listpath 'attributes.lis'], 'r', 'b');

teller = 1;
t = fscanf(fid_att,'%s\n',1);
attributeArray = cellstr(t);
while 1
t = fscanf(fid_att,'%s\n',1);
if(strcmp(t,'END')==1)break;end
attributeArray = [attributeArray cellstr(t)];
end
fclose(fid_att);
antAtt = length(attributeArray); % antall attributter

% Henter inn terskelverdien for aa kunne legge til nye verdier
filepath = [path 'tempFiles/threshold.mat'];
load(filepath);
	if(thresTeller>=antAtt)
		thresTeller=0;
		thresholds = [];
	end
currAttr = attributeArray(thresTeller+1); % current attribute
currAttr = char(currAttr);
attStr = ['current attribute being processed is ' currAttr];
disp(' ')
disp(sprintf('%-50s\n',attStr))

% lese inn modellparametere fra HMM
if nM >= 2
mmfFile = [path 'hmms/hmm' num2str(nM) num2str(nM) '/' 'attrMMF_' currAttr '.mmf'];
else
mmfFile = [path 'hmms/' 'attrMMF_' currAttr '.mmf'];
end
modList = [path listpath 'att.lis'];

cd Matlab;
read_models(mmfFile,modList,nM,vS);
cd ..;

% 'Master Label File' for den aktuelle attributten
labelList = [path listpath 'attribute.mlf'];
type = 'train';

% Liste over mulige fillister
mfcList1 = [path listpath 'trainAll_mfc.lis'];
mfcList2 = [path listpath 'train462_mfc2.lis'];
mfcList3 = [path listpath 'train462_htk_AND_FEmfc.lis'];
mfcList4 = [path listpath 'train462_mfc_NEW.lis'];
mfcList5 = [path listpath 'train462_mfc_NEW_filtered.lis'];
mfcList6 = [path listpath 'train462_mfc_NEW_reducedFEA.lis'];

if mfcTrigger == 1
mfcList = mfcList1;
mfcT = 'Feature_Vectors';
elseif mfcTrigger == 2
mfcList = mfcList2;
mfcT = 'MFCCs';
elseif mfcTrigger == 3
mfcList = mfcList3;
mfcT = 'Feature_Vectors_AND_MFCCs';
elseif mfcTrigger == 4 
mfcList = mfcList4;
mfcT = 'Feature_Vectors_(MFCC_E)';
elseif mfcTrigger == 6 
mfcList = mfcList6;
mfcT = 'Feature vectors_E_redFEA';
else
mfcList = mfcList5;
mfcT = 'Feature_Vectors_(MFCC_E)_FILT';
end
mfcList = filelistSel;

% lese filer og tilegne korrekte etiketter
cd Matlab;
read_mfc_label2(mfcList,labelList,currAttr,Nfiles,mfcTrigger,type,mfcT);
cd ..;

% Kalkulerer logaritmisk pdf-verdien for hver ramme
model = [path 'tempFiles/' 'model_' currAttr '_M' num2str(nM) '.mat'];
cd Matlab;
r= pdfCalc2(type,nS,nM,model,vS,currAttr,mfcT);
cd ..;
naivTerskel = r;

% Kalkulerer terskelverdi
cd Matlab;
r = optThresEERMER(nM,decRule,currAttr,targetChoice);
cd ..;
thresholds = [thresholds; r(1)];
signTh = [signTh; r(2)];
thresTeller = thresTeller + 1;
disp(' ')
disp('thresholdsrarray:');
disp(thresholds);

%  finne feilrate for trening
testdatapath = [path 'tempFiles/testTrainData_M' num2str(nM) '_feature' num2str(mfcTrigger) '_' p '_' decRule '.mat'];
trainRecAll = [path 'tempFiles/trainResult'];
cd Matlab;
trainRecResults = testTrainData(testdatapath, r(1), nM,currAttr,targetChoice,trainRecAll,r(2));
cd ..;

% Lagrer data
save(filepath,'thresholds','thresTeller','signTh');
disp(' ')
disp('End of training')
